/*
 * A dumb audio / video plugin.
 *
 * Copyright (C) 2009 W. Michael Petullo <mike@flyn.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <libdmapsharing/dmap.h>
#include <dmapd/dmapd.h>

G_BEGIN_DECLS

#define TYPE_AV_META_READER_DUMMY          (av_meta_reader_dummy_get_type ())
#define AV_META_READER_DUMMY(o)            (G_TYPE_CHECK_INSTANCE_CAST ((o), \
                                      TYPE_AV_META_READER_DUMMY, AVMetaReaderDummy))
#define AV_META_READER_DUMMY_CLASS(k)      (G_TYPE_CHECK_CLASS_CAST ((k), \
                                      TYPE_AV_META_READER_DUMMY, AVMetaReaderDummyClass))
#define IS_AV_META_READER_DUMMY(o)         (G_TYPE_CHECK_INSTANCE_TYPE ((o), \
                                      TYPE_AV_META_READER_DUMMY))
#define IS_AV_META_READER_DUMMY_CLASS(k)   (G_TYPE_CHECK_CLASS_TYPE ((k), \
                                      TYPE_AV_META_READER_DUMMY_CLASS))
#define AV_META_READER_DUMMY_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), \
                                      TYPE_AV_META_READER_DUMMY, AVMetaReaderDummyClass))
#define AV_META_READER_DUMMY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), \
                                      TYPE_AV_META_READER_DUMMY, AVMetaReaderDummyPrivate))

typedef struct AVMetaReaderDummyPrivate AVMetaReaderDummyPrivate;

typedef struct {
        AVMetaReader parent;
	AVMetaReaderDummyPrivate *priv;
} AVMetaReaderDummy;

typedef struct {
        AVMetaReaderClass parent;
} AVMetaReaderDummyClass;

GType       av_meta_reader_dummy_get_type      (void);

G_END_DECLS

struct AVMetaReaderDummyPrivate {
};

static void
av_meta_reader_dummy_set_property (GObject *object,
				 guint prop_id,
				 const GValue *value,
				 GParamSpec *pspec)
{
	G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
}

static void
av_meta_reader_dummy_get_property (GObject *object,
				 guint prop_id,
				 GValue *value,
				 GParamSpec *pspec)
{
	G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
}

static GOptionGroup *
av_meta_reader_dummy_get_option_group (AVMetaReader *reader)
{
	return NULL;
}

static gboolean
av_meta_reader_dummy_read (AVMetaReader *reader,
			   DAAPRecord *record,
			   const gchar *path)
{
	gint filesize;
	GError *error = NULL;
	gchar *location;

	location = g_strdup_printf ("file//%s", path);

	g_object_set (record, "creation-date", 1,
			      "duration", 10,
			      "has-video", FALSE,
			      "location", location,
			      "title", "Dummy",
			      "artist", "Dummy",
			      "album", "Dummy",
			      "genre", "Dummy",
			      "real-format", "mp3",
			      "format", "mp3",
			      "track", 1,
			      NULL);

	g_free (location);
}

static void
av_meta_reader_dummy_class_finalize (AVMetaReaderDummyClass *klass)
{
}

static void av_meta_reader_dummy_register_type (GTypeModule *module);

G_MODULE_EXPORT gboolean
dmapd_module_load (GTypeModule *module)
{
        av_meta_reader_dummy_register_type (module);
}

G_MODULE_EXPORT gboolean
dmapd_module_unload (GTypeModule *module)
{
}

static void av_meta_reader_dummy_init (AVMetaReaderDummy *reader)
{
	// FIXME: reader->priv = AV_META_READER_DUMMY_GET_PRIVATE (reader);
}

static void av_meta_reader_dummy_class_init (AVMetaReaderDummyClass *klass)
{
	GObjectClass *gobject_class = G_OBJECT_CLASS (klass);
        AVMetaReaderClass *av_meta_reader_class = AV_META_READER_CLASS (klass);

        // FIXME: g_type_class_add_private (klass, sizeof (AVMetaReaderDummyPrivate));

        gobject_class->set_property = av_meta_reader_dummy_set_property;
        gobject_class->get_property = av_meta_reader_dummy_get_property;

        av_meta_reader_class->read = av_meta_reader_dummy_read;
        av_meta_reader_class->get_option_group = av_meta_reader_dummy_get_option_group;	
}

G_DEFINE_DYNAMIC_TYPE (AVMetaReaderDummy,
                       av_meta_reader_dummy,
                       TYPE_AV_META_READER)
